/* $Id: report_relative_droppage.c 2736 2007-10-20 16:59:04Z flaterco $ */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

/* report_relative_droppage cons1.txt const2.txt ... (harmgen outputs)
   Report dropped amplitude relative to remaining amplitude.
*/

/* HARD CODED ********/
#define numcsts 145
#define firstc "J1"

#define linelen 1000

int main (int argc, char **argv) {
  int i, j, junk1, junk2;
  double junk3, droppedamp, t;
  FILE *fp;
  char buf[linelen], name[linelen];
  for (i=1; i<argc; i++) {
    double totalamp = 0.0;
    assert (fp = fopen (argv[i], "r"));
    assert (fgets (buf, linelen, fp));
    assert (fgets (buf, linelen, fp));
    assert (fgets (buf, linelen, fp));
    assert (fgets (buf, linelen, fp));
    assert (sscanf (buf, "# limit %d out of %d constituents, max dropped amp %lf, total %lf", &junk1, &junk2, &junk3, &droppedamp) == 4);
    do {
      assert (fgets (buf, linelen, fp));
    } while (strncmp (buf, firstc, strlen(firstc)));
    assert (sscanf (buf, "%s %lf", name, &t) == 2);
    totalamp += t;
    for (j=1; j<numcsts; j++) {
      assert (fgets (buf, linelen, fp));
      assert (sscanf (buf, "%s %lf", name, &t) == 2);
      totalamp += t;
    }
    fclose (fp);
    printf ("%s lossage is %.4f / %.4f = %2.2f%%.\n", argv[i], droppedamp, totalamp, 100.0*droppedamp/totalamp);
  }
  exit (0);
}
